Dim objShell
set objShell = Wscript.CreateObject("WScript.Shell")

dim filesys
set filesys=CreateObject("Scripting.FileSystemObject")

Dim name

If  Not filesys.FolderExists(objShell.CurrentDirectory + "\residual\") Then
filesys.CreateFolder(objShell.CurrentDirectory + "\residual\")
end if

if filesys.FileExists(objShell.CurrentDirectory + "\standards.cstd") Then
filesys.CopyFile objShell.CurrentDirectory + "\" + "standards.cstd", objShell.CurrentDirectory + "\residual\" + "standards.cstd"
end if

if filesys.FileExists(objShell.CurrentDirectory + "\short.s1p") Then
filesys.CopyFile objShell.CurrentDirectory + "\" + "short.s1p", objShell.CurrentDirectory + "\residual\" + "short.s1p"
end if

if filesys.FileExists(objShell.CurrentDirectory + "\open.s1p") Then
filesys.CopyFile objShell.CurrentDirectory + "\" + "open.s1p", objShell.CurrentDirectory + "\residual\" + "open.s1p"
end if

if filesys.FileExists(objShell.CurrentDirectory + "\load.s1p") Then
filesys.CopyFile objShell.CurrentDirectory + "\" + "load.s1p", objShell.CurrentDirectory + "\residual\" + "load.s1p"
end if

if filesys.FileExists(objShell.CurrentDirectory + "\thru.s2p") Then
filesys.CopyFile objShell.CurrentDirectory + "\" + "thru.s2p", objShell.CurrentDirectory + "\residual\" + "thru.s2p"
end if


set app= CreateObject("LeCroy.SPARQApp.1")

RunOneResidual "LM3",1,3,0
RunOneResidual "OM2",1,2,0
RunOneResidual "SM1",1,1,0
RunOneResidual "LM4",1,4,0
RunOneResidual "OM3",1,3,0
RunOneResidual "SM2",1,2,0
RunOneResidual "LM1",1,1,0
RunOneResidual "OM4",1,4,0
RunOneResidual "SM3",1,3,0
RunOneResidual "LM2",1,2,0
RunOneResidual "OM1",1,1,0
RunOneResidual "SM4",1,4,0
RunOneResidual "TM12",2,1,2
RunOneResidual "TM34",2,3,4
RunOneResidual "TM13",2,1,3
RunOneResidual "TM24",2,2,4
RunOneResidual "TM14",2,1,4
RunOneResidual "TM23",2,2,3

filename = app.SPARQ.ModelName + "_" + app.SPARQ.SerialNumber + "_Residual.L12T"

app.SPARQ.ConvertSecondTierCalibration.CausalityImpulseResponseLimitingEnabled = 0
app.SPARQ.ConvertSecondTierCalibration.CausalityMaxImpulseLength = 1e-9
app.SPARQ.ConvertSecondTierCalibration.EndFrequency = 40e9
app.SPARQ.ConvertSecondTierCalibration.FileName = objShell.CurrentDirectory + "\residual\" + filename
app.SPARQ.ConvertSecondTierCalibration.NumPoints = 8000
app.SPARQ.ConvertSecondTierCalibration.NumPorts = 4
app.SPARQ.ConvertSecondTierCalibration.Type = "SOLT"
app.SPARQ.ConvertSecondTierCalibration.WaveletSmoothingEnabled = 0
app.SPARQ.ConvertSecondTierCalibration.WaveletSmoothingLevels = 32
app.SPARQ.ConvertSecondTierCalibration.WaveletSmoothingPhasesToCheck = 100
app.SPARQ.ConvertSecondTierCalibration.WaveletSmoothingThresholdPercentMax = 0.5
app.SPARQ.ConvertSecondTierCalibration.WaveletSmoothingType = 9

app.SPARQ.Actions.Mode = "OnSeqCompleteAndRecalc"
app.SPARQ.Actions.Enable = 1
app.SPARQ.Actions.Beep = 1
app.SPARQ.Actions.Save = 0

app.SPARQ.ConvertSecondTierCalibration.Convert
app.SPARQ.WaitForSequencer(3600)

set fo=filesys.createtextfile("PASSED.TXT")
fo.writeline("residuals file generated")
fo.close
Wscript.Quit

sub RunOneResidual(meas,ports,port1,port2)

spfilename = objShell.CurrentDirectory + "\residual\" +  meas + ".s" + CStr(ports) + "p"
cfilename = objShell.CurrentDirectory + "\" + meas + ".cal"

app.SPARQ.SecondTierCalibrationFactoryEnabled = 1
app.SPARQ.SecondTierCalibrationUserEnabled = 0
app.SPARQ.NumPoints = 8000
app.SPARQ.AccuracyPreset = "Custom"
app.SPARQ.CustomAccuracyNumAveragesForCal = 50
app.SPARQ.CustomAccuracyNumAveragesForDut = 50
app.SPARQ.CustomAccuracyNumAveragesForResult = 1
app.SPARQ.EndFrequency = 40e9
app.SPARQ.AutoCalPolicy = "RecalibratePeriodically"
app.SPARQ.AutoCalTimeout = 10
app.SPARQ.AppendTimestampToResultsFilename = 0

app.SPARQ.ConvertToUserSParameters = 1

if (ports = 1) then
app.SPARQ.NumPortsInMeasurement = 1
app.SPARQ.UserPortDefinitions = "1"
app.SPARQ.ConverterDefinitions = "1"
app.SPARQ.DutToConverterPinDefinitions = "1"
app.SPARQ.DutSparqPortMapping = CStr(port1)
else
app.SPARQ.NumPortsInMeasurement = 2
app.SPARQ.UserPortDefinitions = "1,2"
app.SPARQ.ConverterDefinitions = "1,2"
app.SPARQ.DutToConverterPinDefinitions = "1,2"
app.SPARQ.DutSparqPortMapping = CStr(port1) + "," + CSTR(port2)
end if

app.SPARQ.DeEmbedCables = 1
app.SPARQ.Actions.Mode = "OnSeqCompleteAndRecalc"
app.SPARQ.Actions.Enable = 1
app.SPARQ.Actions.Beep = 1
app.SPARQ.Actions.Save = 0
app.SPARQ.SParameterResultsFilename = spfilename 
app.SPARQ.CalFilename = cfilename
app.SPARQ.LoadCalFromFile
app.SPARQ.Recalculate
app.SPARQ.WaitForSequencer(3600)
app.SPARQ.SaveSParameterResults

end sub